#include <bits/stdc++.h>
using namespace std;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    long long n;
    int k;
    cin>>n>>k;
    vector<long long>d(k);
    for(int i=0;i<k;i++)
        cin>>d[i];
    vector<long long>redsosled=d;
    sort(d.begin(),d.end());
    unordered_map<long long,int>id;
    id.reserve(k*2);
    for(int i=0;i<k;i++){
        id[d[i]]=i;}
    vector<long long>dp(k,0);
    for(int i=0;i<k;i++){
        long long x=d[i];
        for(int j=i;j<k;j++) {
            if (d[j]%x==0) {
                dp[j]^=x;}}}
    for(long long v:redsosled){
        cout<<dp[id[v]]<<" ";}
    cout << "\n";
    return 0;}